## mingw-w64-trilinos-16.1.0-1.src.tar.zst

=== packages/PyTrilinos2/CMakeLists.txt ===
# Set the package name
TRIBITS_PACKAGE(PyTrilinos2 DISABLE_STRONG_WARNINGS)

IF(NOT BUILD_SHARED_LIBS)
  MESSAGE(FATAL_ERROR "PyTrilinos2 can only be built with shared libraries. Building of shared libraries is currently set to OFF. To enable shared libraries please set the cache variable \"BUILD_SHARED_LIBS\" to ON")
ENDIF()

# Set the package version number
SET(PyTrilinos2_VERSION ${Trilinos_VERSION})

TRIBITS_ADD_OPTION_AND_DEFINE(PyTrilinos2_BINDER_SUPPRESS_ERRORS
  PYTRILINOS2_SUPPRESS_ERRORS
  "Enable the suppress errors option of binder."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(PyTrilinos2_BINDER_USE_ONE_FILE
  PYTRILINOS2_USE_ONE_FILE
  "Enable the use of one file by binder."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(PyTrilinos2_BINDER_CMAKE_ERROR
PYTRILINOS2_CMAKE_ERROR
  "Stop the configuration if binder fails."
  ON )

TRIBITS_ADD_OPTION_AND_DEFINE(PyTrilinos2_BINDER_VERBOSE
  PYTRILINOS2_VERBOSE
  "Increase the verbosity of binder."
  OFF )

SET(PyTrilinos2_BINDER_NUM_FILES "150" CACHE STRING "Maxinum number of generated files by binder.")

MESSAGE("-- Python3_EXECUTABLE:")
IF(NOT DEFINED ${Python3_EXECUTABLE})
  find_program(Python3_EXECUTABLE
      NAMES python3 python
      )
  MESSAGE("  -- CMake has set: Python3_EXECUTABLE = ${Python3_EXECUTABLE}")
ELSE()
  MESSAGE("  -- User has set: Python3_EXECUTABLE = ${Python3_EXECUTABLE}")
ENDIF()

function(get_all_include_dirs  LIBRARY_NAME all_include_dirs all_visited_libs)
  if (TARGET ${LIBRARY_NAME})
    get_property(depend_libs TARGET ${LIBRARY_NAME} PROPERTY INTERFACE_LINK_LIBRARIES)
    foreach(depend_lib IN LISTS depend_libs)
      if (TARGET ${depend_lib} AND (NOT ${depend_lib} IN_LIST all_visited_libs))
        list(APPEND all_visited_libs "${depend_lib}") # Update list in the current scope only
        get_property(current_includes TARGET ${depend_lib} PROPERTY INTERFACE_INCLUDE_DIRECTORIES)
        foreach(include IN LISTS current_includes)
          STRING(REPLACE "$<BUILD_INTERFACE:" "" new_tmp_include ${include})
          STRING(REPLACE ">" "" new_include ${new_tmp_include})
          list(APPEND all_include_dirs "${new_include}") # Update list in the current scope only
        endforeach()
        get_all_include_dirs(${depend_lib} "${all_include_dirs}" "${all_visited_libs}")
      endif()
    endforeach()
    set(all_include_dirs ${all_include_dirs} PARENT_SCOPE)
    set(all_visited_libs ${all_visited_libs} PARENT_SCOPE)
  endif()
endfunction()

# Python files to install
FILE(GLOB PyTrilinos2PyFiles ${CMAKE_CURRENT_SOURCE_DIR}/python/*.py)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/PyTrilinos2)

MESSAGE("-- PyTrilinos2_BINDER_EXECUTABLE:")
IF(NOT DEFINED PyTrilinos2_BINDER_EXECUTABLE)
  find_program(PyTrilinos2_BINDER_EXECUTABLE
      NAMES binder
      )
  MESSAGE("  -- CMake has set: PyTrilinos2_BINDER_EXECUTABLE = ${PyTrilinos2_BINDER_EXECUTABLE}")
ELSE()
  MESSAGE("  -- User has set: PyTrilinos2_BINDER_EXECUTABLE = ${PyTrilinos2_BINDER_EXECUTABLE}")
ENDIF()
file(REMOVE_RECURSE ${CMAKE_CURRENT_BINARY_DIR}/include_tmp)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include_tmp)
file(REMOVE_RECURSE ${CMAKE_CURRENT_BINARY_DIR}/binder)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/binder)

set(binder_include_name "${CMAKE_CURRENT_BINARY_DIR}/trilinos_includes.hpp")
set(all_header_with_dir_list "${CMAKE_CURRENT_BINARY_DIR}/list_with_dir.txt")
set(all_header_without_dir_list "${CMAKE_CURRENT_BINARY_DIR}/list_without_dir.txt")
set(all_ETI_files_list "${CMAKE_CURRENT_BINARY_DIR}/all_ETI_files_list.txt")
set(all_ETI_classes_list "${CMAKE_CURRENT_BINARY_DIR}/all_ETI_classes_list.txt")
set(all_include_list "${CMAKE_CURRENT_BINARY_DIR}/list_include.txt")

set(all_include_dirs "")
set(all_visited_libs "")
foreach(depPkg IN LISTS PyTrilinos2_LIB_ENABLED_DEPENDENCIES)
  get_all_include_dirs(${depPkg}::all_libs "${all_include_dirs}" "${all_visited_libs}")
endforeach()

foreach(all_include_dir IN LISTS all_include_dirs)
  STRING(FIND ${all_include_dir} "kokkos/algorithms/src" IS_KOKKOS_ALGORITHMS_SRC)
  IF(${IS_KOKKOS_ALGORITHMS_SRC} GREATER -1)
    list(APPEND all_include_dirs "${all_include_dir}/std_algorithms")
    list(APPEND all_include_dirs "${all_include_dir}/std_algorithms/impl")
    list(APPEND all_include_dirs "${all_include_dir}/sorting")
    list(APPEND all_include_dirs "${all_include_dir}/sorting/impl")
  ENDIF()
endforeach()

list(REMOVE_DUPLICATES all_include_dirs)
list(REMOVE_ITEM all_include_dirs "")
#MESSAGE("all_include_dirs = ${all_include_dirs}")

set(PyTrilinos2_all_include_files_with_dir "")
set(PyTrilinos2_all_include_files_without_dir "")
foreach(include_dir IN LISTS all_include_dirs)
  file(GLOB include_files
      "${include_dir}/*.hpp"
      "${include_dir}/*.h"
      "${include_dir}/*/*.hpp"
      "${include_dir}/*/*.h"
      "${include_dir}/*/*/*.hpp"
      "${include_dir}/*/*/*.h"
      "${include_dir}/*/*/*/*.hpp"
      "${include_dir}/*/*/*/*.h"
      "${include_dir}/*/*/*/*.inc"
      "${include_dir}/*/*/*/*.inc_predicate"
  )
  foreach(include_file IN LISTS include_files)
    list(APPEND PyTrilinos2_all_include_files_with_dir "${include_file}")
    string(REPLACE "${include_dir}/" "" include_file_without_dir "${include_file}")
    list(APPEND PyTrilinos2_all_include_files_without_dir "${include_file_without_dir}")
  endforeach()
endforeach()


#list(REMOVE_DUPLICATES PyTrilinos2_all_include_files_without_dir)
#list(REMOVE_ITEM PyTrilinos2_all_include_files_without_dir "")

#list(REMOVE_DUPLICATES PyTrilinos2_all_include_files_with_dir)
#list(REMOVE_ITEM PyTrilinos2_all_include_files_with_dir "")

#MESSAGE("PyTrilinos2_all_include_files_with_dir = ${PyTrilinos2_all_include_files_with_dir}")

SET(CONTENTS "")
FOREACH(line IN LISTS all_include_dirs)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
file(WRITE ${all_include_list} ${CONTENTS})

set(eti_files_with_dir "")
set(eti_files_without_dir "")

# Get ETI files for Tpetra:
file(GLOB tpetra_ETI_files
    "${CMAKE_CURRENT_BINARY_DIR}/../tpetra/core/src/*.cpp"
)
list(APPEND tpetra_ETI_files "${CMAKE_CURRENT_BINARY_DIR}/../tpetra/core/src/TpetraCore_ETIHelperMacros.h")

foreach(tpetra_ETI_file IN LISTS tpetra_ETI_files)
  list(APPEND eti_files_with_dir "${tpetra_ETI_file}")
  get_filename_component(tpetra_ETI_file_without_dir "${tpetra_ETI_file}" NAME)
  list(APPEND eti_files_without_dir "${tpetra_ETI_file_without_dir}")
endforeach()

SET(CONTENTS "")
FOREACH(line IN LISTS PyTrilinos2_all_include_files_with_dir)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
FOREACH(line IN LISTS eti_files_with_dir)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
file(WRITE ${all_header_with_dir_list} ${CONTENTS})

SET(CONTENTS "")
FOREACH(line IN LISTS PyTrilinos2_all_include_files_without_dir)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
FOREACH(line IN LISTS eti_files_without_dir)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
file(WRITE ${all_header_without_dir_list} ${CONTENTS})

SET(CONTENTS "")
FOREACH(line IN LISTS eti_files_without_dir)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
file(WRITE ${all_ETI_files_list} ${CONTENTS})

SET(ETI_classes "Tpetra_CrsMatrix;Tpetra_Vector;Tpetra_MultiVector;Tpetra_FEMultiVector;Tpetra_FECrsMatrix")
SET(CONTENTS "")
FOREACH(line IN LISTS ETI_classes)
  SET(CONTENTS "${CONTENTS}${line}\n")
ENDFOREACH(line)
file(WRITE ${all_ETI_classes_list} ${CONTENTS})

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/python)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/src)

add_custom_command(
  OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/src/PyTrilinos2_Tpetra_ETI.hpp ${CMAKE_CURRENT_BINARY_DIR}/python/getTpetraTypeName.py
  COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/scripts/gather_ETI.py ${CMAKE_CURRENT_BINARY_DIR} ${all_ETI_files_list} ${all_ETI_classes_list} "src/PyTrilinos2_Tpetra_ETI.hpp"
  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/include_tmp
)
add_custom_target(generate_ETI_name DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/src/PyTrilinos2_Tpetra_ETI.hpp ${CMAKE_CURRENT_BINARY_DIR}/include_tmp)

file (GLOB PyTrilinos2PyFiles2 "${CMAKE_CURRENT_BINARY_DIR}/python/*.py")
list (APPEND PyTrilinos2PyFiles ${PyTrilinos2PyFiles2})

add_custom_command(
  OUTPUT  ${binder_include_name}
  COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/scripts/gather_includes.py ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${all_header_with_dir_list} ${all_header_without_dir_list} ${binder_include_name}
  DEPENDS generate_ETI_name ${CMAKE_CURRENT_BINARY_DIR}/include_tmp
)
add_custom_target(generate_include_name DEPENDS ${binder_include_name})
add_dependencies(generate_include_name generate_ETI_name)

ASSERT_DEFINED(
  ${PACKAGE_NAME}_ENABLE_MueLu
)

set(BINDER_OPTIONS "")
list(APPEND BINDER_OPTIONS --root-module PyTrilinos2)
list(APPEND BINDER_OPTIONS --prefix ${CMAKE_CURRENT_BINARY_DIR}/binder)
IF(PYTRILINOS2_USE_ONE_FILE)
  list(APPEND BINDER_OPTIONS -single-file)
ELSE()
  list(APPEND BINDER_OPTIONS -max-file-size=1000000)
  list(APPEND BINDER_OPTIONS -flat)
ENDIF()
list(APPEND BINDER_OPTIONS --bind Teuchos)
list(APPEND BINDER_OPTIONS --bind Tpetra)
list(APPEND BINDER_OPTIONS --bind Thyra)
list(APPEND BINDER_OPTIONS --bind ThyraTpetraAdapters)
list(APPEND BINDER_OPTIONS --bind Stratimikos)
IF(${PACKAGE_NAME}_ENABLE_MueLu)
  list(APPEND BINDER_OPTIONS --bind MueLu)
ENDIF()
IF(PYTRILINOS2_VERBOSE)
  list(APPEND BINDER_OPTIONS -v)
ENDIF()
IF(PYTRILINOS2_SUPPRESS_ERRORS)
  list(APPEND BINDER_OPTIONS --suppress-errors)
ENDIF()
list(APPEND BINDER_OPTIONS --config ${CMAKE_CURRENT_SOURCE_DIR}/scripts/PyTrilinos2_config.cfg)
list(APPEND BINDER_OPTIONS --)
IF(TPL_ENABLE_CUDA)
  list(APPEND BINDER_OPTIONS -x cuda --cuda-host-only)
ENDIF()
list(APPEND BINDER_OPTIONS ${PyTrilinos2_BINDER_FLAGS})
list(APPEND BINDER_OPTIONS -std=c++17)
if (NOT(MPI_BASE_DIR STREQUAL ""))
  list(APPEND BINDER_OPTIONS -I${MPI_BASE_DIR}/include)
ENDIF()
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/mdspan)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/View/MDSpan)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/experimental)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/experimental/__p0009_bits)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/experimental/__p1684_bits)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/experimental/__p2389_bits)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/experimental/__p2630_bits)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/include_tmp/experimental/__p2642_bits)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_BINARY_DIR}/src)
list(APPEND BINDER_OPTIONS -I${CMAKE_CURRENT_SOURCE_DIR}/src)
IF(NOT DEFINED PyTrilinos2_BINDER_GCC_TOOLCHAIN)
  list(APPEND BINDER_OPTIONS -I${PyTrilinos2_BINDER_clang_include_dirs})
  list(APPEND BINDER_OPTIONS -iwithsysroot${PyTrilinos2_BINDER_LibClang_include_dir})
ELSE()
  list(APPEND BINDER_OPTIONS --gcc-toolchain=${PyTrilinos2_BINDER_GCC_TOOLCHAIN})
ENDIF()
list(APPEND BINDER_OPTIONS -DNDEBUG)

message("BINDER_OPTIONS='${BINDER_OPTIONS}'")

add_custom_command(
  OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/binder/PyTrilinos2.cpp
  COMMAND ${PyTrilinos2_BINDER_EXECUTABLE} ${binder_include_name} ${BINDER_OPTIONS}
  DEPENDS ${binder_include_name} generate_include_name
)
add_custom_target(binder_call DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/binder/PyTrilinos2.cpp)
add_dependencies(binder_call generate_ETI_name generate_include_name)

IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  SET(PyTrilinos2_DEFAULT_INSTALL_PREFIX ${PYTHON_PREFIX})
ELSE()
  SET(PyTrilinos2_DEFAULT_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
ENDIF()

# Set the PyTrilinos2 install prefix
SET(PyTrilinos2_INSTALL_PREFIX ${PyTrilinos2_DEFAULT_INSTALL_PREFIX}
  CACHE PATH "The path prefix for where PyTrilinos2 will be installed, e.g. /usr/local")

=== packages/amesos2/CMakeLists.txt ===

#
# A) Define the package
#

TRIBITS_PACKAGE(Amesos2)

SET(${PACKAGE_NAME_UC}_VERSION "0.3d")

#
# B) Set up package-specific options
#

IF (${PACKAGE_NAME}_ENABLE_MUMPS AND NOT Tpetra_INST_INT_INT)
   MESSAGE(WARNING "*****Amesos2 will not provide MUMPS Support with Tpetra_INST_INT_INT OFF.*****")
  SET(HAVE_${PACKAGE_NAME_UC}_MUMPS OFF)
ENDIF ()

IF (Amesos2_ENABLE_UMFPACK)
  IF (Trilinos_ENABLE_COMPLEX_FLOAT AND NOT Trilinos_ENABLE_COMPLEX_DOUBLE)
    MESSAGE(WARNING "*****Amesos2 is building Umfpack without a complex<double> type. Umfpack natively supports only complex<double> types, not complex<float> types, and this will lead to type conversions. *****")
  ENDIF()
  # This may not happen anyways… right now it seems we can’t compile this package with Trilinos_ENABLE_FLOAT and TPetra_INST_DOUBLE turned off - need to resolve.
  IF (NOT Tpetra_INST_DOUBLE)
    MESSAGE(WARNING "*****Amesos2 is building Umfpack without a double type. Umfpack natively supports only double types, not float types, and this will lead to type conversions. *****")
  ENDIF()
ENDIF()

IF (Amesos2_ENABLE_CSS_MKL)
  IF (NOT ${PACKAGE_NAME}_ENABLE_PARDISO_MKL OR NOT TPL_ENABLE_MPI)
    MESSAGE(WARNING "*****Amesos2_ENABLE_CSS_MKL requires PARDISO_MKL and MPI. Turning off CSS_MKL. *****")
    SET(Amesos2_ENABLE_CSS_MKL OFF)
    SET(HAVE_AMESOS2_CSS_MKL OFF)
  ENDIF()
ENDIF()

# if using SuperLU_5.0, must use the proper API
IF(${PACKAGE_NAME}_ENABLE_SuperLU)
  IF(NOT ${PROJECT_NAME}_ENABLE_SuperLU5_API)

   SET(HAVE_AMESOS2_SUPERLU5_API OFF)

  ELSE()

   SET(HAVE_AMESOS2_SUPERLU5_API ON)

  ENDIF()
ENDIF()


TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_VERBOSE_DEBUG
  HAVE_${PACKAGE_NAME_UC}_VERBOSE_DEBUG
  "Enable verbose output during debug-mode"
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_TIMERS
  HAVE_${PACKAGE_NAME_UC}_TIMERS
  "Enable performance timers"
  OFF )

#
# TPL Solver interfaces are enabled automatically based on Trilinos
# TPL configuration.
#
# Config options such as Amesos2_ENABLE_XXXXXX are automatically
# generated in case a user would wish to explicitely disable Amesos2
# support for an otherwise enabled third-part solver library
#


TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KLU2
  HAVE_AMESOS2_KLU2
  "Enable KLU2 in Amesos2"
  ON
)

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Basker
   HAVE_AMESOS2_BASKER
   "Enable Basker in Amesos2"
   OFF
)

IF (NOT Kokkos_ENABLE_OPENMP OR Kokkos_ENABLE_CUDA OR Kokkos_ENABLE_HIP)
  tribits_disable_optional_dependency(ShyLU_NodeBasker "NOTE: Disabling ${PACKAGE_NAME}_ENABLE_ShyLU_NodeBasker because CUDA or HIP is enabled in Kokkos or OpenMP is not enabled in Kokkos")
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_AMESOS2_EXPERIMENTAL
  "Enable building and installation of experimental Amesos2 features."
  NO 
)

TRIBITS_ADD_DEBUG_OPTION()

TRIBITS_ADD_EXPLICIT_INSTANTIATION_OPTION()

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# D) Do standard postprocessing
#

#leaving in place for future excludes
#TRIBITS_EXCLUDE_FILES(
#  )

TRIBITS_PACKAGE_POSTPROCESS()

=== commonTools/build_stats/unit_tests/CMakeLists.txt ===
TRIBITS_ADD_ADVANCED_TEST( summarize_build_stats_UnitTests
  OVERALL_WORKING_DIRECTORY TEST_NAME
  OVERALL_NUM_MPI_PROCS 1
  TEST_0 CMND ${Python3_EXECUTABLE}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/summarize_build_stats_UnitTests.py -v
    PASS_REGULAR_EXPRESSION "OK"
    ALWAYS_FAIL_ON_NONZERO_RETURN
  )

TRIBITS_ADD_ADVANCED_TEST( gather_build_stats_UnitTests
  OVERALL_WORKING_DIRECTORY TEST_NAME
  OVERALL_NUM_MPI_PROCS 1
  TEST_0 CMND ${Python3_EXECUTABLE}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/gather_build_stats_UnitTests.py -v
    PASS_REGULAR_EXPRESSION "OK"
    ALWAYS_FAIL_ON_NONZERO_RETURN
  )

=== packages/belos/test/CMakeLists.txt ===

ADD_SUBDIRECTORY(BlockCG)
ADD_SUBDIRECTORY(BlockGmres)
ADD_SUBDIRECTORY(Factory)
ADD_SUBDIRECTORY(GCRODR)
ADD_SUBDIRECTORY(Util)

# mfh 10 Jan 2013: MINRES test is taking a long time and causing test timeouts.
# It's not obviously broken, so I'm disabling the test for now until we can find
# a different test problem that doesn't take so long.
#ADD_SUBDIRECTORY(MINRES)
ADD_SUBDIRECTORY(MVOPTester)

IF(${PACKAGE_NAME}_ENABLE_Experimental)
  ADD_SUBDIRECTORY(ProjectedLeastSquaresSolver)
ENDIF()

ADD_SUBDIRECTORY(RealSolverManager)
ADD_SUBDIRECTORY(TFQMR)

=== packages/ifpack/test/CMakeLists.txt ===

IF (NOT Trilinos_NO_32BIT_GLOBAL_INDICES)

ADD_SUBDIRECTORIES(
  CompareWithAztecOO
  Container
  CrsRiluk
  IC
  ILU
  IHSS-SORa
  IlukGraph
  OverlappingRowMatrix
  Performance
  PreconditionerFactory
  Relaxation
  SetParameters
  TriDi
  TestAll
  BlockCheby
  #UseTranspose
  )

IF (${PACKAGE_NAME}_ENABLE_SUPPORTGRAPH)
  ADD_SUBDIRECTORY(SupportGraph)
ENDIF ()
IF (${PACKAGE_NAME}_ENABLE_AztecOO)
  ADD_SUBDIRECTORY(AztecOO)
ENDIF()
IF (${PACKAGE_NAME}_ENABLE_HYPRE)
  ADD_SUBDIRECTORY(Hypre)
ENDIF()

ENDIF()

IF (NOT Trilinos_NO_64BIT_GLOBAL_INDICES)

ADD_SUBDIRECTORIES(
  CompareWithAztecOO_LL
  Container_LL
  CrsRiluk_LL
  IC_LL
  ILU_LL
  IHSS-SORa_LL
  IlukGraph_LL
  OverlappingRowMatrix_LL
  PreconditionerFactory_LL
  Relaxation_LL
  SetParameters_LL
  TestAll_LL
  BlockCheby_LL
  )
IF (${PACKAGE_NAME}_ENABLE_AztecOO)
  ADD_SUBDIRECTORY(AztecOO_LL)
ENDIF()
IF (HAVE_HYPRE)
  ADD_SUBDIRECTORY(Hypre_LL)
ENDIF()

ENDIF()

=== packages/stk/stk_middle_mesh_util/CMakeLists.txt ===

STK_SUBPACKAGE(Middle_mesh_util)

ADD_SUBDIRECTORY(stk_middle_mesh_util)

STK_SUBPACKAGE_POSTPROCESS()

=== packages/teuchos/remainder/CMakeLists.txt ===

TRIBITS_SUBPACKAGE(Remainder)

ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_EXPLICIT_INSTANTIATION)

TRIBITS_ADD_OPTION_AND_DEFINE(
  Trilinos_ENABLE_LINEAR_SOLVER_FACTORY_REGISTRATION
  TRILINOS_HAVE_LINEAR_SOLVER_FACTORY_REGISTRATION
  "Whether to enable automatic run-time registration of LinearSolverFactory in downstream packages.  All packages that intend to register a LinearSolverFactory at run time, before main() starts, must respect this option.  Its default value is ${PROJECT_NAME}_ENABLE_EXPLICIT_INSTANTIATION = ${${PROJECT_NAME}_ENABLE_EXPLICIT_INSTANTIATION}, because if explicit template instantiation (ETI) is OFF, the automatic registration option increases build time.  The LinearSolver and LinearSolverFactory interfaces remain even if this option is OFF, but in that case, users must do manual registration for all solver packages which they (or solvers) might like to use."
  ${${PROJECT_NAME}_ENABLE_EXPLICIT_INSTANTIATION}
  )

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_TEST_DIRECTORIES(example)

TRIBITS_SUBPACKAGE_POSTPROCESS()

=== packages/epetra/doc/OskiInterface/Makefile ===
all:
	pdflatex EpetraOskiInterface
	bibtex   EpetraOskiInterface
	pdflatex EpetraOskiInterface
	pdflatex EpetraOskiInterface
clean:
	@rm -f EpetraOskiInterface.aux
	@rm -f EpetraOskiInterface.log
	@rm -f EpetraOskiInterface.dvi
	@rm -f EpetraOskiInterface.bbl
	@rm -f EpetraOskiInterface.blg
	@rm -f EpetraOskiInterface.pdf

=== packages/epetra/test/MapColoring/CMakeLists.txt ===

TRIBITS_ADD_EXECUTABLE_AND_TEST(
  MapColoring_test
  SOURCES cxx_main.cpp
  ARGS -v
  COMM mpi serial
  NUM_MPI_PROCS 1
  FAIL_REGULAR_EXPRESSION "tests FAILED"
  )

=== packages/epetraext/test/MatrixMatrix/CMakeLists.txt ===



TRIBITS_ADD_EXECUTABLE_AND_TEST(
  MatrixMatrix_test
  SOURCES cxx_main.cpp
  ARGS -v
  COMM serial mpi
  )


TRIBITS_COPY_FILES_TO_BINARY_DIR(MatrixMatrixCopyFiles
  DEST_FILES
    infileAB infileATBT infileAB2 infiles infileABT infileAB3 infileAB4 infileATB infileATB2
    infile6x4TI6 infileI4x6x4T infilePTxI infileIxPT
    C.mtx C4x4.mtx C4x12x12x4.mtx C4x6.mtx C6x4.mtx C6x6.mtx mat6x4.mtx mat6x6.mtx
    C6x4TxI6.mtx CI4x6x4T.mtx I3.mtx I4.mtx I6.mtx I9.mtx P.mtx PT.mtx
    mat12x4.mtx mat4x12.mtx mat4x4.mtx mat4x6.mtx Y.mtx YTC.mtx Y_transp.mtx
    roman roman2 romancase romancase2 cdt cdt_case cdt_d.mtx cdt_m.mtx cdt_tce.mtx
  SOURCE_DIR ${PACKAGE_SOURCE_DIR}/test/MatrixMatrix
  SOURCE_PREFIX "src_"
  EXEDEPS MatrixMatrix_test
  )

=== packages/epetraext/test/Permutation/CMakeLists.txt ===



TRIBITS_ADD_EXECUTABLE_AND_TEST(
  Permutation_test
  SOURCES cxx_main.cpp
  ARGS -v
  COMM serial mpi
  )

=== packages/kokkos/core/unit_test/CMakeLists.txt ===
#
# Add test-only library for gtest to be reused by all the subpackages
#

if(NOT GTest_FOUND) # fallback to internal gtest
  set(GTEST_SOURCE_DIR ${Kokkos_SOURCE_DIR}/tpls/gtest)

  kokkos_add_test_library(
    kokkos_gtest HEADERS ${GTEST_SOURCE_DIR}/gtest/gtest.h SOURCES ${GTEST_SOURCE_DIR}/gtest/gtest-all.cc
  )

  target_include_directories(kokkos_gtest SYSTEM PUBLIC ${GTEST_SOURCE_DIR})
  if((NOT (Kokkos_ENABLE_CUDA AND WIN32)) AND (NOT ("${KOKKOS_CXX_COMPILER_ID}" STREQUAL "Fujitsu")))
    target_compile_features(kokkos_gtest PUBLIC cxx_std_14)
  endif()

  # Suppress clang-tidy diagnostics on code that we do not have control over
  if(CMAKE_CXX_CLANG_TIDY)
    set_target_properties(kokkos_gtest PROPERTIES CXX_CLANG_TIDY "")
  endif()

  find_package(Threads QUIET)
  if(TARGET Threads::Threads)
    set_target_properties(kokkos_gtest PROPERTIES INTERFACE_LINK_LIBRARIES Threads::Threads)
  endif()
endif()

#
# Define Incremental Testing Feature Levels
# Define Device name mappings (i.e. what comes after Kokkos:: for the ExecSpace)
#

set(KOKKOS_CUDA_FEATURE_LEVEL 999)
set(KOKKOS_CUDA_NAME Cuda)
set(KOKKOS_HIP_FEATURE_LEVEL 999)
set(KOKKOS_HIP_NAME HIP)
set(KOKKOS_HPX_FEATURE_LEVEL 999)
set(KOKKOS_HPX_NAME Experimental::HPX)
set(KOKKOS_OPENMP_FEATURE_LEVEL 999)
set(KOKKOS_OPENMP_NAME OpenMP)

# FIXME_OPENMPTARGET - The NVIDIA HPC compiler nvc++ only compiles the first 8 incremental tests for the OpenMPTarget backend.
# FIXME_OPENMPTARGET - Clang version 17 fails to compile incremental tests past 12 with verion 17. There is PR for this in upstream already. So it should be fixed by version 18.
if(KOKKOS_CXX_COMPILER_ID STREQUAL NVHPC)
  set(KOKKOS_OPENMPTARGET_FEATURE_LEVEL 10)
elseif(KOKKOS_CXX_COMPILER_ID STREQUAL "Clang" AND KOKKOS_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 17.0.0)
  set(KOKKOS_OPENMPTARGET_FEATURE_LEVEL 12)
else()
  set(KOKKOS_OPENMPTARGET_FEATURE_LEVEL 14)
endif()

set(KOKKOS_OPENMPTARGET_NAME Experimental::OpenMPTarget)
set(KOKKOS_SERIAL_FEATURE_LEVEL 999)
set(KOKKOS_SERIAL_NAME Serial)
set(KOKKOS_SYCL_FEATURE_LEVEL 999)
set(KOKKOS_SYCL_NAME SYCL)
set(KOKKOS_THREADS_FEATURE_LEVEL 999)
set(KOKKOS_THREADS_NAME Threads)
# FIXME_OPENACC - The Clang compiler only compiles the first 9 incremental tests for the OpenACC backend.
if(KOKKOS_CXX_COMPILER_ID STREQUAL Clang)
  set(KOKKOS_OPENACC_FEATURE_LEVEL 9)
else()
  set(KOKKOS_OPENACC_FEATURE_LEVEL 17)
endif()

set(KOKKOS_OPENACC_NAME Experimental::OpenACC)

#
# Define the tests
#

#I will leave these alone for now because I don't need transitive dependencies on tests
kokkos_include_directories(${CMAKE_CURRENT_BINARY_DIR})
kokkos_include_directories(REQUIRED_DURING_INSTALLATION_TESTING ${CMAKE_CURRENT_SOURCE_DIR})
kokkos_include_directories(${KOKKOS_SOURCE_DIR}/core/unit_test/category_files)

set(COMPILE_ONLY_SOURCES
    TestArray.cpp
    TestCreateMirror.cpp
    TestDetectionIdiom.cpp
    TestBitManipulation.cpp
    TestInterOp.cpp
    TestRangePolicyCTAD.cpp
    TestStringManipulation.cpp
    TestVersionMacros.cpp
    TestViewRank.cpp
    TestViewTypeTraits.cpp
    TestViewTypedefs.cpp
    TestTypeInfo.cpp
    TestTypeList.cpp
    TestMDRangePolicyCTAD.cpp
    TestTeamPolicyCTAD.cpp
    TestTeamMDRangePolicyCTAD.cpp
    TestNestedReducerCTAD.cpp
    view/TestBasicViewMDSpanConversion.cpp
    view/TestExtentsDatatypeConversion.cpp
)

if(NOT Kokkos_ENABLE_IMPL_MDSPAN OR KOKKOS_CXX_COMPILER_ID STREQUAL "Intel")
  list(REMOVE_ITEM COMPILE_ONLY_SOURCES view/TestBasicViewMDSpanConversion.cpp)
endif()

#testing if windows.h and Kokkos_Core.hpp can be included
if(WIN32)
  list(APPEND COMPILE_ONLY_SOURCES TestWindowsInclude.cpp)
endif()

if(Kokkos_INSTALL_TESTING) # FIXME Kokkos_ and KOKKOS_ variables are out of sync
  if((Kokkos_CXX_COMPILER_ID STREQUAL "Intel" AND Kokkos_CXX_COMPILER_VERSION VERSION_LESS 2021.2.0)
     OR (Kokkos_CXX_COMPILER_ID STREQUAL "NVIDIA" AND Kokkos_CXX_COMPILER_VERSION VERSION_LESS 11.3.0)
     OR (Kokkos_CXX_COMPILER_ID STREQUAL "NVIDIA" AND Kokkos_CXX_HOST_COMPILER_ID STREQUAL "MSVC")
  )
    list(REMOVE_ITEM COMPILE_ONLY_SOURCES TestTypeInfo.cpp)
  endif()
else()
  if((KOKKOS_CXX_COMPILER_ID STREQUAL "Intel" AND KOKKOS_CXX_COMPILER_VERSION VERSION_LESS 2021.2.0)
     OR (KOKKOS_CXX_COMPILER_ID STREQUAL "NVIDIA" AND KOKKOS_CXX_COMPILER_VERSION VERSION_LESS 11.3.0)
     OR (KOKKOS_CXX_COMPILER_ID STREQUAL "NVIDIA" AND KOKKOS_CXX_HOST_COMPILER_ID STREQUAL "MSVC")
  )
    list(REMOVE_ITEM COMPILE_ONLY_SOURCES TestTypeInfo.cpp)
  endif()
endif()

if(Kokkos_ENABLE_OPENMPTARGET)
  list(REMOVE_ITEM COMPILE_ONLY_SOURCES TestNestedReducerCTAD.cpp)
endif()
kokkos_add_executable(CoreTestCompileOnly SOURCES TestCompileMain.cpp ${COMPILE_ONLY_SOURCES})

foreach(Tag Threads;Serial;OpenMP;Cuda;HPX;OpenMPTarget;OpenACC;HIP;SYCL)
  string(TOUPPER ${Tag} DEVICE)
  string(TOLOWER ${Tag} dir)

  if(Kokkos_ENABLE_${DEVICE})
    set(dir ${CMAKE_CURRENT_BINARY_DIR}/${dir})
    file(MAKE_DIRECTORY ${dir})
    # Needed to split this for Windows NVCC, since it ends up putting everything on the
    # command line in an intermediate compilation step even if CMake generated a response
    # file. That then exceeded the shell command line max length.
    set(${Tag}_SOURCES1A)
    foreach(
      Name
      Abort
      ArrayOps
      AtomicOperations_complexdouble
      AtomicOperations_complexfloat
      AtomicOperations_double
      AtomicOperations_float
      AtomicOperations_int
      AtomicOperations_longint
      AtomicOperations_longlongint
      AtomicOperations_shared
      AtomicOperations_unsignedint
      AtomicOperations_unsignedlongint
      Atomics
      AtomicViews
      BitManipulationBuiltins
      BlockSizeDeduction
      CheckedIntegerOps
      CommonPolicyConstructors
      CommonPolicyInterface
      Complex
      Concepts
      Crs
      DeepCopyAlignment
      ExecSpacePartitioning
      ExecSpaceThreadSafety
      ExecutionSpace
      FunctorAnalysis
      Graph
      HostSharedPtr
      HostSharedPtrAccessOnDevice
      Init
      JoinBackwardCompatibility
      LocalDeepCopy
      MathematicalConstants
      MathematicalFunctions1
      MathematicalFunctions2
      MathematicalFunctions3
      MathematicalSpecialFunctions
    )
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp "#include <Test${Tag}_Category.hpp>\n" "#include <Test${Name}.hpp>\n")
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ${Tag}_SOURCES1A ${file})
    endforeach()

    set(${Tag}_SOURCES1B)
    set(${Tag}_TESTNAMES1B
        MDRange_a
        MDRange_b
        MDRange_c
        MDRange_d
        MDRange_e
        MDRange_f
        MDRange_g
        MDRangePolicyConstructors
        MDRangeReduce
        MDSpan
        MDSpanAtomicAccessor
        MDSpanConversion
        MinMaxClamp
        NumericTraits
        OccupancyControlTrait
        Other
        ParallelScanRangePolicy
        Printf
        QuadPrecisionMath
        RangePolicy
        RangePolicyConstructors
        RangePolicyRequire
        ReducerCTADs
        Reducers_a
        Reducers_b
        Reducers_c
        Reducers_d
        Reducers_e
        Reductions
        Reductions_DeviceView
        SharedAlloc
        SpaceAwareAccessorAccessViolation
        SpaceAwareAccessor
        Swap
    )
    if(NOT Kokkos_ENABLE_IMPL_MDSPAN)
      list(REMOVE_ITEM ${Tag}_TESTNAMES1B MDSpanAtomicAccessor MDSpanConversion SpaceAwareAccessorAccessViolation
           SpaceAwareAccessor
      )
    endif()
    # This test case causes MSVC to fail with "number of sections exceeded object file format limit"
    if(MSVC)
      list(REMOVE_ITEM ${Tag}_TESTNAMES1B Reducers_d)
    endif()
    foreach(Name IN LISTS ${Tag}_TESTNAMES1B)
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp "#include <Test${Tag}_Category.hpp>\n" "#include <Test${Name}.hpp>\n")
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ${Tag}_SOURCES1B ${file})
    endforeach()

    set(${Tag}_SOURCES2A)
    set(${Tag}_TESTNAMES2A
        TeamBasic
        TeamCombinedReducers
        TeamMDRange
        TeamPolicyConstructors
        TeamReductionScan
        TeamScan
        TeamScratch
        TeamTeamSize
        TeamVectorRange
        UniqueToken
        View_64bit
        ViewAPI_a
        ViewAPI_b
        ViewAPI_c
        ViewAPI_d
        ViewAPI_e
        ViewBadAlloc
        ViewCopy_a
        ViewCopy_b
        ViewCopy_c
        ViewCtorDimMatch
        ViewCtorProp
        ViewEmptyRuntimeUnmanaged
        ViewHooks
        ViewLayoutStrideAssignment
        ViewMapping_a
        ViewMapping_b
        ViewMapping_subview
        ViewMemoryAccessViolation
        ViewOfClass
        ViewOfViews
        ViewOutOfBoundsAccess
        ViewResize
        WorkGraph
        WithoutInitializing
    )
    # Workaround to internal compiler error with intel classic compilers
    # when using -no-ip flag in ViewCopy_c
    # See issue: https://github.com/kokkos/kokkos/issues/7084
    if(KOKKOS_CXX_COMPILER_ID STREQUAL Intel)
      list(REMOVE_ITEM ${Tag}_TESTNAMES2A ViewCopy_c)
    endif()
    foreach(Name IN LISTS ${Tag}_TESTNAMES2A)
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp "#include <Test${Tag}_Category.hpp>\n" "#include <Test${Name}.hpp>\n")
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ${Tag}_SOURCES2A ${file})
    endforeach()

    set(TagHostAccessible ${Tag})
    if(Tag STREQUAL "Cuda")
      set(TagHostAccessible CudaUVM)
    elseif(Tag STREQUAL "HIP")
      set(TagHostAccessible HIPManaged)
    elseif(Tag STREQUAL "SYCL")
      set(TagHostAccessible SYCLSharedUSM)
    endif()

    set(${Tag}_SOURCES2B)
    foreach(
      Name
      SubView_a
      SubView_b
      SubView_c01
      SubView_c02
      SubView_c03
      SubView_c04
      SubView_c05
    )
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp "#include <Test${TagHostAccessible}_Category.hpp>\n" "#include <Test${Name}.hpp>\n")
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ${Tag}_SOURCES2B ${file})
    endforeach()

    set(${Tag}_SOURCES2C)
    foreach(Name SubView_c06 SubView_c07 SubView_c08 SubView_c09)
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp "#include <Test${TagHostAccessible}_Category.hpp>\n" "#include <Test${Name}.hpp>\n")
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ${Tag}_SOURCES2C ${file})
    endforeach()

    set(${Tag}_SOURCES2D)
    foreach(Name SubView_c10 SubView_c11 SubView_c12 SubView_c13 SubView_c14)
      set(file ${dir}/Test${Tag}_${Name}.cpp)
      # Write to a temporary intermediate file and call configure_file to avoid
      # updating timestamps triggering unnecessary rebuilds on subsequent cmake runs.
      file(WRITE ${dir}/dummy.cpp "#include <Test${TagHostAccessible}_Category.hpp>\n" "#include <Test${Name}.hpp>\n")
      configure_file(${dir}/dummy.cpp ${file})
      list(APPEND ${Tag}_SOURCES2D ${file})
    endforeach()

    set(${Tag}_SOURCES1 ${${Tag}_SOURCES1A} ${${Tag}_SOURCES1B})

=== PKGBUILD ===
# Maintainer: Martin Diehl <aur@martin-diehl.net>
# Contributor: Alad Wenter <alad@archlinux.org>
# Contributor: Jingbei Li <i@jingbei.li>
# Contributor: Simon Pintarelli <simon.pintarelli@gmail.com>
# Contributor: Feng Wang <wanng.fenng@gmail.com>
# Contributor (msys): Rafal Brzegowy <rafal.brzegowy@yahoo.com>

_realname=trilinos
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=16.1.0
_pkgver=${pkgver//./-}
pkgrel=1
pkgdesc='Algorithms for the solution of large-scale scientific problems" (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="http://trilinos.org"
msys2_repository_url="https://github.com/trilinos/Trilinos"
license=('spdx:BSD-3-Clause AND LGPL-2.1-or-later')
depends=("${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-openblas"
         "${MINGW_PACKAGE_PREFIX}-boost"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-matio"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         $([[ ${CARCH} == aarch64 ]] || echo "${MINGW_PACKAGE_PREFIX}-msmpi"))
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-perl"
             "${MINGW_PACKAGE_PREFIX}-bc"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "unzip")
optdepends=("${MINGW_PACKAGE_PREFIX}-seacas")
provides=("${MINGW_PACKAGE_PREFIX}-kokkos")
source=("https://github.com/${_realname}/Trilinos/archive/${_realname}-release-${_pkgver}.tar.gz"
        "001-aarch64-clang.patch")
sha256sums=('e9651c88f581049457036cfc01b527a9d3903c257338eeeab942befd7452f23a'
            '4aa0ec733709ba9dc9f7425efb2fec5ae975c2be99601e06c5a82ef9933218ee')
noextract=(${_realname}-release-${_pkgver}.tar.gz)

apply_patch_with_msg() {
  for _fname in "$@"
  do
    msg2 "Applying ${_fname}"
    patch -Nbp1 -i "${srcdir}"/${_fname}
  done
}

prepare(){
  tar -xzf ${_realname}-release-${_pkgver}.tar.gz || true

  cd "Trilinos-${_realname}-release-${_pkgver}"

  apply_patch_with_msg \
    001-aarch64-clang.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} != CLANG* ]]; then
    extra_config+=("-DCMAKE_Fortran_FLAGS='$FCFLAGS -fallow-argument-mismatch'")
  fi

  if [[ "${CARCH}" == "aarch64" ]]; then
    extra_config+=("-DKokkos_ARCH_ARMV81=ON")
  fi  

  #Static Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-static" && cd "${srcdir}/build-${MSYSTEM}-static"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DBLAS_LIBRARY_NAMES="openblas" \
      -DLAPACK_LIBRARY_NAMES="openblas" \
      -DTrilinos_ENABLE_Fortran=ON \
      -DTrilinos_ENABLE_ALL_OPTIONAL_PACKAGES=ON \
      -DTrilinos_ENABLE_ALL_PACKAGES=ON \
      -DTPL_ENABLE_DLlib=OFF \
      -DTrilinos_ENABLE_Xpetra=OFF \
      -DTrilinos_ENABLE_Epetra=ON \
      -DTrilinos_ENABLE_Intrepid2=OFF \
      -DTrilinos_ENABLE_SEACAS=OFF \
      -DTrilinos_ENABLE_Gtest=OFF \
      -DTPL_ENABLE_gtest=OFF \
      -DTrilinos_ENABLE_TESTS=OFF \
      ../Trilinos-${_realname}-release-${_pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .

  #Shared Build
  mkdir -p "${srcdir}/build-${MSYSTEM}-shared" && cd "${srcdir}/build-${MSYSTEM}-shared"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      "${extra_config[@]}" \
      -DBUILD_SHARED_LIBS=ON \
      -DBLAS_LIBRARY_NAMES="openblas" \
      -DLAPACK_LIBRARY_NAMES="openblas" \
      -DTrilinos_ENABLE_Fortran=ON \
      -DTrilinos_ENABLE_ALL_OPTIONAL_PACKAGES=ON \
      -DTrilinos_ENABLE_ALL_PACKAGES=ON \
      -DTPL_ENABLE_DLlib=OFF \
      -DTrilinos_ENABLE_Xpetra=OFF \
      -DTrilinos_ENABLE_Epetra=ON \
      -DTrilinos_ENABLE_Intrepid2=OFF \
      -DTrilinos_ENABLE_SEACAS=OFF \
      -DTrilinos_ENABLE_Gtest=OFF \
      -DTPL_ENABLE_gtest=OFF \
      -DTrilinos_ENABLE_TESTS=OFF \
      ../Trilinos-${_realname}-release-${_pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  #Static Install
  cd "${srcdir}/build-${MSYSTEM}-static"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .

  #Shared Install
  cd "${srcdir}/build-${MSYSTEM}-shared"
  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install .
  install -Dm644 "${srcdir}"/Trilinos-${_realname}-release-${_pkgver}/LICENSE "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE

  # Remove conflict with seacas package
  #rm -r "${pkgdir}"${MINGW_PREFIX}/lib/external_packages/DLlib
}
